# OpenCV增加支持奥比中光Astra系列3D深度相机

**OpenCV**（nightly builds）**增加支持奥比中光Astra系列3D深度相机！**

![](https://maoxianxin1996.oss-accelerate.aliyuncs.com/codechina/20210608175723.png)

<div align="center">
Astra系列3D深度相机
</div>

Astra系列3D深度相机是全球领先的3D感知技术方案提供商奥比中光科技集团股份有限公司最经典和最畅销的3D深度相机系列之一。该系列采用单目结构光技术，具有高精度、低功耗、响应迅速、稳定可靠的优点，能够覆盖近距离和中远距离的多种室内场景应用，如面部识别、手势识别、人体跟踪、三维测量、环境感知和三维地图重建等。

![](https://maoxianxin1996.oss-accelerate.aliyuncs.com/codechina/20210608175815.png)

<div align="center">
Astra系列硬件结构和特点
</div>

OpenCV增加对Astra系列3D深度相机的支持后，就可以使用cv::VideoCapture直接获取深度传感器信息，与使用其获取彩色相机视频流的过程一致，极大的方便了开发。

```
// 打开深度视频流
VideoCapture depthStream(CAP_OPENNI2_ASTRA);

// 设置深度信息流的参数
depthStream.set(CAP_PROP_FRAME_WIDTH,  640);
depthStream.set(CAP_PROP_FRAME_HEIGHT, 480);
depthStream.set(CAP_PROP_OPENNI2_MIRROR, 0);

// 获取深度视频流
Frame depthFrame;
depthStream.grab();
depthStream.retrieve(depthFrame.frame, CAP_OPENNI_DEPTH_MAP);

// 显示深度帧
Mat depthMap = depthFrame.frame;
Mat d8, dColor;
depthMap.convertTo(d8, CV_8U, 255.0 / 2500);
applyColorMap(d8, dColor, COLORMAP_OCEAN);
imshow("Depth (colored)", dColor);
```

![](https://maoxianxin1996.oss-accelerate.aliyuncs.com/codechina/20210608175850.png)

<div align="center">
第一张是深度图，第二张是彩色图
</div>

在彩色图中，不容易区分花盆里的树叶和墙上的树叶，但在深度图中就一目了然

- 完整的使用OpenCV获取Astra 3D相机的教程请参: 

  [https://docs.opencv.org/master/d4/d65/tutorial_orbbec_astra.html](https://docs.opencv.org/master/d4/d65/tutorial_orbbec_astra.html)

- 完整的代码请参考：

  [https://github.com/opencv/opencv/blob/master/samples/cpp/tutorial_code/videoio/orbbec_astra/orbbec_astra.cpp](https://github.com/opencv/opencv/blob/master/samples/cpp/tutorial_code/videoio/orbbec_astra/orbbec_astra.cpp)

大家可以使用最新OpenCV源码抢先一试：

```
git clone https://github.com/opencv/opencv.git
```

![](https://maoxianxin1996.oss-accelerate.aliyuncs.com/codechina/20210608112105.png)